package Examples
  package Example_1
    package Generator
      model Generator
        extends OpenIPSL.Interfaces.Generator;
        OpenIPSL.Electrical.Machines.PSAT.Order6 order6(D = 5, M = 7, P_0 = P_0, Q_0 = Q_0, Sn = 2220, T1q0 = 1, T2d0 = 0.03, T2q0 = 0.07, Taa = 0.002, V_0 = V_0, V_b = V_b, Vn = 400, angle_0 = angle_0, ra = 0.003, x1d = 0.3, x1q = 0.65, x2d = 0.23, x2q = 0.25, xd = 1.81, xq = 1.76) annotation (
          Placement(visible = true, transformation(origin = {9, -5}, extent = {{-15, -15}, {15, 15}}, rotation = 0)));
        OpenIPSL.Electrical.Controls.PSAT.AVR.AVRtypeIII aVRtypeIII(K0 = 10, T1 = 1, T2 = 1, Te = 0.0001, Tr = 0.015, vfmax = 7, vfmin = -6.4) annotation (
          Placement(visible = true, transformation(origin = {-52, 6}, extent = {{-12, -12}, {12, 12}}, rotation = 0)));
        Modelica.Blocks.Sources.Constant pss_off(k = 0) annotation (
          Placement(visible = true, transformation(origin = {-88, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      equation
        connect(order6.pm0, order6.pm) annotation (
          Line(points={{-3,-21.5},{-3,-21.5},{-3,-30},{-18,-30},{-18,-12},{-9,
                -12},{-9,-12.5}},                                                                          color = {0, 0, 127}));
        connect(order6.v, aVRtypeIII.v) annotation (
          Line(points={{25.5,-0.5},{38,-0.5},{38,26},{-70,26},{-70,12},{-63,12},
                {-63,12}},                                                                        color = {0, 0, 127}));
      connect(order6.vf0, aVRtypeIII.vf0) annotation (
          Line(points={{-3,11.5},{-3,24},{-52,24},{-52,17}},        color = {0, 0, 127}));
      connect(aVRtypeIII.vf, order6.vf) annotation (
          Line(points={{-39,6},{-23,6},{-23,2.5},{-9,2.5}},      color = {0, 0, 127}));
      connect(order6.p, pwPin) annotation (
          Line(points = {{24, -5}, {62, -5}, {62, 0}, {110, 0}}, color = {0, 0, 255}));
        connect(pss_off.y, aVRtypeIII.vs) annotation (
          Line(points={{-77,0},{-64,0},{-64,0},{-63,0}},          color = {0, 0, 127}));
      end Generator;

      model GenEventTest "Configuration of synchronous generator with regulators: GENSAL, HYGOV, SCRX, STAB2A;
  Nordic 44 model: Buses 3115, 5300, 6100, 6700, 7100"
        extends OpenIPSL.Electrical.Essentials.pfComponent;
        OpenIPSL.Electrical.Machines.PSSE.GENSAL gENSAL(
          Tppd0=0.05 "T''do (> 0)",
          Tppq0=0.15 "T''qo (> 0)",
          D=0 "Speed Damping",
          Tpd0=6.4,
          H=3.5,
          Xd=1.14,
          Xq=0.84,
          Xpd=0.34,
          Xppd=0.26,
          Xppq=0.26,
          Xl=0.2,
          M_b=1200,
          S10=0.1,
          S12=0.3,
          R_a=0,
          V_b=V_b,
          V_0=V_0,
          angle_0=angle_0,
          P_0=P_0,
          Q_0=Q_0) annotation (Placement(transformation(extent={{-64,-24},{-2,40}})));
        OpenIPSL.Electrical.Controls.PSSE.TG.HYGOV hYGOV(
          R=0.06 "Permanent droop, p.u",
          r=0.4 "Temporary droop, p.u",
          VELM=0.2 "Gate open/close velosiy limit, p.u/sec",
          T_r=5,
          T_f=0.05,
          T_g=0.2,
          G_MAX=1,
          G_MIN=0,
          T_w=1,
          A_t=1.1,
          D_turb=0.5,
          q_NL=0.1) annotation (Placement(transformation(extent={{-62,62},{10,90}})));
        OpenIPSL.Electrical.Controls.PSSE.ES.EXST1 eXST1_1(
          T_B=13, K_C=1)
          annotation (Placement(transformation(extent={{24,-82},{82,-34}})));
        Modelica.Blocks.Sources.Constant cte(k=0)
          annotation (Placement(transformation(extent={{-22,-70},{-10,-58}})));
        OpenIPSL.Electrical.Controls.PSSE.PSS.STAB2A sTAB2A(
          H_LIM=0.03,
          K_2=1,
          T_2=4.5,
          K_3=0,
          T_3=2,
          K_4=0.55,
          K_5=1,
          T_5=0.01)
          annotation (Placement(transformation(extent={{-66,-54},{-20,-34}})));
        OpenIPSL.Interfaces.PwPin p annotation (Placement(transformation(rotation=0,
                extent={{100,-10},{120,10}}), iconTransformation(extent={{100,-10},{
                  120,10}})));
      equation
        connect(gENSAL.p, p)
          annotation (Line(points={{-2,8},{82,8},{82,0},{110,0}},  color={0,0,255}));
        connect(sTAB2A.VOTHSG, eXST1_1.VOTHSG) annotation (Line(points={{
                -17.9091,-44},{-17.9091,-43.3333},{24,-43.3333}}, color={0,0,
                127}));
        connect(cte.y, eXST1_1.VOEL) annotation (Line(points={{-9.4,-64},{-2,
                -64},{-2,-82},{42.85,-82}},     color={0,0,127}));
        connect(eXST1_1.EFD, gENSAL.EFD) annotation (Line(points={{83.45,
                -55.3333},{84,-55.3333},{84,-86},{-78,-86},{-78,-8},{-70.2,-8}},
              color={0,0,127}));
        connect(gENSAL.PELEC, sTAB2A.PELEC) annotation (Line(points={{1.1,17.6},
                {10,17.6},{10,-30},{-72,-30},{-72,-44},{-65.3727,-44}},
                                                              color={0,0,127}));
        connect(gENSAL.XADIFD, eXST1_1.XADIFD) annotation (Line(points={{0.48,
                -20.8},{8,-20.8},{8,-64.6667},{24,-64.6667}}, color={0,0,127}));
        connect(gENSAL.EFD0, eXST1_1.EFD0) annotation (Line(points={{1.1,-8},{
                12,-8},{12,-72.6667},{24,-72.6667}}, color={0,0,127}));
        connect(hYGOV.PMECH, gENSAL.PMECH) annotation (Line(points={{11.8,76},{
                18,76},{18,46},{-76,46},{-76,24},{-70.2,24}},
                                                        color={0,0,127}));
        connect(gENSAL.SPEED, hYGOV.SPEED) annotation (Line(points={{1.1,30.4},
                {24,30.4},{24,92},{-66,92},{-66,83},{-61.1,83}},
                                                             color={0,0,127}));
        connect(gENSAL.PMECH0, hYGOV.PMECH0) annotation (Line(points={{1.1,24},
                {32,24},{32,96},{-78,96},{-78,69},{-61.1,69}},
                                                             color={0,0,127}));
        connect(gENSAL.ETERM, eXST1_1.ECOMP) annotation (Line(points={{1.1,-1.6},
                {16,-1.6},{16,-55.3333},{24,-55.3333}}, color={0,0,127}));
        connect(eXST1_1.VUEL, cte.y) annotation (Line(points={{34.15,-82},{-2,
                -82},{-2,-64},{-9.4,-64}},
                                      color={0,0,127}));
        annotation (
          Icon(graphics={Ellipse(extent={{-100,-100},{101,100}}, lineColor={0,0,255}),
                Line(
                points={{-76,-26},{-28,52},{27,-52},{74,23}},
                color={0,0,255},
                smooth=Smooth.Bezier)}),
          Diagram(coordinateSystem(preserveAspectRatio=false, extent={{-100,-100},{
                  100,100}})),
          Documentation);
      end GenEventTest;
    end Generator;

    model Network
    Examples.Example_1.Generator.Generator G1(P_0 = 1997.999, Q_0 = 967.92, V_0 = 1, V_b = 400, angle_0 = 28.3385, displayPF = true)  annotation (
        Placement(visible = true, transformation(origin = {-88, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B1(displayPF=true) annotation (
        Placement(visible = true, transformation(origin = {-60, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B2(displayPF=true) annotation (
        Placement(visible = true, transformation(origin = {-20, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B3(displayPF=true) annotation (
        Placement(visible = true, transformation(origin = {40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      inner OpenIPSL.Electrical.SystemBase SysData(S_b=100, fn=60) annotation (
        Placement(visible = true, transformation(origin = {-70, 85}, extent = {{-30, -15}, {30, 15}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PSAT.TwoWindingTransformer
        twoWindingTransformer(
        Sn=2220,
        V_b=400,
        Vn=400,
        kT=1,
        r=0.0,
        x=0.15) annotation (
        Placement(visible = true, transformation(origin = {-40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine1(
        B=0.0,
        G=0.0,
        R=0.0,
        X=0.5*100/2220) annotation (
        Placement(visible = true, transformation(origin = {10, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine2(
        B=0.0,
        G=0.0,
        R=0.0,
        X=0.93*100/2220) annotation (
        Placement(visible = true, transformation(origin = {10, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.InfiniteBus infiniteBus(
        P_0=-1998,
        Q_0=87.066,
        V_0=0.90081,
        V_b=400,
        angle_0=0.0) annotation (
        Placement(visible = true, transformation(origin = {78, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Events.PwFault pwFault(
        R=0.0,
        X=0.01*100/2220,
        t1=0.5,
        t2=0.57) annotation (
        Placement(visible = true, transformation(origin = {2, -38}, extent = {{-6, -6}, {6, 6}}, rotation = 0)));
    equation
      connect(infiniteBus.p, B3.p) annotation (
        Line(points = {{68, 0}, {40, 0}}, color = {0, 0, 255}));
      connect(pwFault.p, B2.p) annotation (
        Line(points={{-5,-38},{-16,-38},{-16,0},{-20,0}},          color = {0, 0, 255}));
      connect(pwLine1.p, B2.p) annotation (
        Line(points={{1,20},{-8,20},{-8,0},{-20,0}},          color = {0, 0, 255}));
      connect(pwLine2.p, B2.p) annotation (
        Line(points={{1,-20},{-8,-20},{-8,0},{-20,0}},          color = {0, 0, 255}));
      connect(pwLine2.n, B3.p) annotation (
        Line(points={{19,-20},{30,-20},{30,0},{40,0},{40,0}},            color = {0, 0, 255}));
      connect(pwLine1.n, B3.p) annotation (
        Line(points={{19,20},{30,20},{30,0},{40,0},{40,0}},            color = {0, 0, 255}));
      connect(twoWindingTransformer.n, B2.p) annotation (
        Line(points={{-29,0},{-20,0},{-20,0},{-20,0}},          color = {0, 0, 255}));
      connect(twoWindingTransformer.p, B1.p) annotation (
        Line(points={{-51,0},{-60,0},{-60,0},{-60,0}},          color = {0, 0, 255}));
      connect(G1.pwPin, B1.p) annotation (
        Line(points={{-77,0},{-62,0},{-62,0},{-60,0}},          color = {0, 0, 255}));
        annotation (
      experiment(
        StartTime=0,
        StopTime=10,
        Tolerance=1e-6,
        Interval=1e-4),
      Documentation);
    end Network;

    model Network2
      Examples.Example_1.Generator.Generator G1(P_0 = 1997.999, Q_0 = 967.92, V_0 = 1, V_b = 400, angle_0 = 28.3385, displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {-98, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B1(displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {-80, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B2(displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {-40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B3(displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {58, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      inner OpenIPSL.Electrical.SystemBase SysData(S_b = 100, fn = 60) annotation (
        Placement(visible = true, transformation(origin = {-70, 85}, extent = {{-30, -15}, {30, 15}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PSAT.TwoWindingTransformer twoWindingTransformer(Sn = 2220, V_b = 400, Vn = 400, kT = 1, r = 0.0, x = 0.15) annotation (
        Placement(visible = true, transformation(origin = {-60, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine1(B = 0.0, G = 0.0, R = 0.0, X = 0.5 * 100 / 2220) annotation (
        Placement(visible = true, transformation(origin = {30, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine2(B = 0.0, G = 0.0, R = 0.0, X = 0.93 * 100 / 2220, t1 = 1) annotation (
        Placement(visible = true, transformation(origin = {30, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.InfiniteBus infiniteBus(P_0 = -1998, Q_0 = 87.066, V_0 = 0.90081, V_b = 400, angle_0 = 0.0) annotation (
        Placement(visible = true, transformation(origin = {102, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Events.Breaker breaker1(rc_enabled=false) annotation (
        Placement(visible = true, transformation(origin = {-4, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Events.Breaker breaker2(rc_enabled=false) annotation (
        Placement(visible = true, transformation(origin = {-4, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(B3.p, infiniteBus.p) annotation (
        Line(points = {{58, 0}, {92, 0}, {92, 0}, {92, 0}}, color = {0, 0, 255}));
      connect(pwLine2.n, B3.p) annotation (
        Line(points={{39,-20},{44,-20},{44,0},{58,0}},          color = {0, 0, 255}));
      connect(pwLine1.n, B3.p) annotation (
        Line(points={{39,20},{44,20},{44,0},{58,0}},          color = {0, 0, 255}));
      connect(breaker1.r, pwLine1.p) annotation (
        Line(points={{6,20},{22,20},{22,20},{21,20}},          color = {0, 0, 255}));
      connect(breaker2.r, pwLine2.p) annotation (
        Line(points={{6,-20},{21,-20}},      color = {0, 0, 255}));
      connect(breaker1.s, B2.p) annotation (
        Line(points={{-14,20},{-26,20},{-26,0},{-40,0},{-40,0}},            color = {0, 0, 255}));
      connect(breaker2.s, B2.p) annotation (
        Line(points={{-14,-20},{-26,-20},{-26,0},{-40,0},{-40,0}},            color = {0, 0, 255}));
      connect(twoWindingTransformer.n, B2.p) annotation (
        Line(points={{-49,0},{-41,0},{-41,0},{-40,0}},          color = {0, 0, 255}));
      connect(G1.pwPin, B1.p) annotation (
        Line(points={{-87,0},{-80,0}},      color = {0, 0, 255}));
      connect(twoWindingTransformer.p, B1.p) annotation (
        Line(points={{-71,0},{-80,0}},      color = {0, 0, 255}));
      annotation (
        experiment(StartTime = 0, StopTime = 10, Tolerance = 1e-6, Interval = 1e-4),
        Documentation,
        Diagram(coordinateSystem(extent={{-120,-100},{120,100}})),
        Icon(coordinateSystem(extent={{-120,-100},{120,100}})),
        __OpenModelica_commandLineOptions="");
    end Network2;

    model Network3
    Generator.GenEventTest                 G1(P_0 = 1997.999, Q_0 = 967.92, V_0 = 1, V_b = 400, angle_0 = 28.3385)                    annotation (
        Placement(visible = true, transformation(origin = {-88, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B1(displayPF=true) annotation (
        Placement(visible = true, transformation(origin = {-60, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B2(displayPF=true) annotation (
        Placement(visible = true, transformation(origin = {-20, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B3(displayPF=true) annotation (
        Placement(visible = true, transformation(origin = {40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      inner OpenIPSL.Electrical.SystemBase SysData(S_b=100, fn=60) annotation (
        Placement(visible = true, transformation(origin = {-70, 85}, extent = {{-30, -15}, {30, 15}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PSAT.TwoWindingTransformer
        twoWindingTransformer(
        Sn=2220,
        V_b=400,
        Vn=400,
        kT=1,
        r=0.0,
        x=0.15) annotation (
        Placement(visible = true, transformation(origin = {-40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine1(
        B=0.0,
        G=0.0,
        R=0.0,
        X=0.5*100/2220) annotation (
        Placement(visible = true, transformation(origin = {10, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine2(
        B=0.0,
        G=0.0,
        R=0.0,
        X=0.93*100/2220) annotation (
        Placement(visible = true, transformation(origin = {10, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.InfiniteBus infiniteBus(
        P_0=-1998,
        Q_0=87.066,
        V_0=0.90081,
        V_b=400,
        angle_0=0.0) annotation (
        Placement(visible = true, transformation(origin = {78, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Events.PwFault pwFault(
        R=0.0,
        X=0.01*100/2220,
        t1=0.5,
        t2=0.56) annotation (
        Placement(visible = true, transformation(origin = {2, -38}, extent = {{-6, -6}, {6, 6}}, rotation = 0)));
    equation
      connect(infiniteBus.p, B3.p) annotation (
        Line(points = {{68, 0}, {40, 0}}, color = {0, 0, 255}));
      connect(pwFault.p, B2.p) annotation (
        Line(points={{-5,-38},{-16,-38},{-16,0},{-20,0}},          color = {0, 0, 255}));
      connect(pwLine1.p, B2.p) annotation (
        Line(points={{1,20},{-8,20},{-8,0},{-20,0}},          color = {0, 0, 255}));
      connect(pwLine2.p, B2.p) annotation (
        Line(points={{1,-20},{-8,-20},{-8,0},{-20,0}},          color = {0, 0, 255}));
      connect(pwLine2.n, B3.p) annotation (
        Line(points={{19,-20},{30,-20},{30,0},{40,0},{40,0}},            color = {0, 0, 255}));
      connect(pwLine1.n, B3.p) annotation (
        Line(points={{19,20},{30,20},{30,0},{40,0},{40,0}},            color = {0, 0, 255}));
      connect(twoWindingTransformer.n, B2.p) annotation (
        Line(points={{-29,0},{-20,0},{-20,0},{-20,0}},          color = {0, 0, 255}));
      connect(twoWindingTransformer.p, B1.p) annotation (
        Line(points={{-51,0},{-60,0},{-60,0},{-60,0}},          color = {0, 0, 255}));
      connect(G1.p, B1.p)
        annotation (Line(points={{-77,0},{-60,0}}, color={0,0,255}));
        annotation (
      experiment(
        StartTime=0,
        StopTime=10,
        Tolerance=1e-6,
        Interval=1e-4),
      Documentation);
    end Network3;
  end Example_1;




  package Example_2
    package Generator
      model Generator
        extends OpenIPSL.Interfaces.Generator;
        OpenIPSL.Electrical.Machines.PSAT.Order6 order6(D = 0, M = 7, P_0 = P_0, Q_0 = Q_0, Sn = 2220, T1q0 = 1, T2d0 = 0.03, T2q0 = 0.07, Taa = 0.002, V_0 = V_0, V_b = V_b, Vn = 400, angle_0 = angle_0, ra = 0.003, x1d = 0.3, x1q = 0.65, x2d = 0.23, x2q = 0.25, xd = 1.81, xq = 1.76) annotation (
          Placement(visible = true, transformation(origin = {9, -5}, extent = {{-15, -15}, {15, 15}}, rotation = 0)));
        OpenIPSL.Electrical.Controls.PSAT.AVR.AVRtypeIII aVRtypeIII(K0 = 200, T1 = 1, T2 = 1, Te = 0.0001, Tr = 0.015, vfmax = 7, vfmin = -6.4) annotation (
          Placement(visible = true, transformation(origin = {-52, 6}, extent = {{-12, -12}, {12, 12}}, rotation = 0)));
        OpenIPSL.Electrical.Controls.PSAT.PSS.PSSTypeII pss(
          Kw=9.5,
          T1=0.154,
          T2=0.033,
          T3=1,
          T4=1,
          Tw=1.41,
          vsmax=0.2,
          vsmin=-0.2) annotation (
          Placement(visible = true, transformation(origin = {-84, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      equation
        connect(pss.vSI, order6.w) annotation (
          Line(points = {{-94, 0}, {-100, 0}, {-100, 30}, {32, 30}, {32, 8}, {26, 8}, {26, 8}}, color = {0, 0, 127}));
        connect(pss.vs, aVRtypeIII.vs) annotation (
          Line(points = {{-72, 0}, {-64, 0}, {-64, 0}, {-62, 0}}, color = {0, 0, 127}));
        connect(order6.pm0, order6.pm) annotation (
          Line(points = {{-4, -22}, {-4, -22}, {-4, -30}, {-18, -30}, {-18, -12}, {-10, -12}, {-10, -12}}, color = {0, 0, 127}));
        connect(order6.v, aVRtypeIII.v) annotation (
          Line(points = {{26, 0}, {38, 0}, {38, 26}, {-70, 26}, {-70, 12}, {-62, 12}, {-62, 12}}, color = {0, 0, 127}));
        connect(order6.vf0, aVRtypeIII.vf0) annotation (
          Line(points = {{-3, 12}, {-3, 24}, {-52, 24}, {-52, 18}}, color = {0, 0, 127}));
        connect(aVRtypeIII.vf, order6.vf) annotation (
          Line(points = {{-38, 6}, {-23, 6}, {-23, 3}, {-9, 3}}, color = {0, 0, 127}));
        connect(order6.p, pwPin) annotation (
          Line(points = {{24, -5}, {62, -5}, {62, 0}, {110, 0}}, color = {0, 0, 255}));
      end Generator;
    end Generator;

    model Network
      OpenIPSL.Electrical.Buses.Bus B1(displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {-60, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B2(displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {-20, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B3(displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      inner OpenIPSL.Electrical.SystemBase SysData(S_b = 100, fn = 60) annotation (
        Placement(visible = true, transformation(origin = {-70, 85}, extent = {{-30, -15}, {30, 15}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PSAT.TwoWindingTransformer twoWindingTransformer(Sn = 2220, V_b = 400, Vn = 400, kT = 1, r = 0.0, x = 0.15) annotation (
        Placement(visible = true, transformation(origin = {-40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine1(B = 0.0, G = 0.0, R = 0.0, X = 0.5 * 100 / 2220) annotation (
        Placement(visible = true, transformation(origin = {10, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine2(B = 0.0, G = 0.0, R = 0.0, X = 0.93 * 100 / 2220) annotation (
        Placement(visible = true, transformation(origin = {10, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.InfiniteBus infiniteBus(P_0 = -1998, Q_0 = 87.066, V_0 = 0.90081, V_b = 400, angle_0 = 0.0) annotation (
        Placement(visible = true, transformation(origin = {78, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Events.PwFault pwFault(R = 0.0, X = 0.01 * 100 / 2220, t1 = 0.5, t2 = 0.57) annotation (
        Placement(visible = true, transformation(origin = {2, -38}, extent = {{-6, -6}, {6, 6}}, rotation = 0)));
      Generator.Generator G1(
        P_0=1997.999,
        Q_0=967.92,
        V_0=1,
        V_b=400,
        angle_0=28.3385) annotation (
        Placement(visible = true, transformation(origin = {-82, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(G1.pwPin, B1.p) annotation (
        Line(points = {{-70, 0}, {-60, 0}, {-60, 0}, {-60, 0}}, color = {0, 0, 255}));
      connect(infiniteBus.p, B3.p) annotation (
        Line(points = {{68, 0}, {40, 0}}, color = {0, 0, 255}));
      connect(pwFault.p, B2.p) annotation (
        Line(points = {{-7, -38}, {-16, -38}, {-16, 0}, {-20, 0}}, color = {0, 0, 255}));
      connect(pwLine1.p, B2.p) annotation (
        Line(points = {{0, 20}, {-8, 20}, {-8, 0}, {-20, 0}}, color = {0, 0, 255}));
      connect(pwLine2.p, B2.p) annotation (
        Line(points = {{2, -20}, {-8, -20}, {-8, 0}, {-20, 0}}, color = {0, 0, 255}));
      connect(pwLine2.n, B3.p) annotation (
        Line(points = {{20, -20}, {30, -20}, {30, 0}, {40, 0}, {40, 0}}, color = {0, 0, 255}));
      connect(pwLine1.n, B3.p) annotation (
        Line(points = {{20, 20}, {30, 20}, {30, 0}, {40, 0}, {40, 0}}, color = {0, 0, 255}));
      connect(twoWindingTransformer.n, B2.p) annotation (
        Line(points = {{-28, 0}, {-20, 0}, {-20, 0}, {-20, 0}}, color = {0, 0, 255}));
      connect(twoWindingTransformer.p, B1.p) annotation (
        Line(points = {{-52, 0}, {-60, 0}, {-60, 0}, {-60, 0}}, color = {0, 0, 255}));
    end Network;
  end Example_2;

  package Example_1Mod
    package Generator
      model Generator
        extends OpenIPSL.Interfaces.Generator;
        OpenIPSL.Electrical.Machines.PSAT.Order6 order6(D = 0, M = 7, P_0 = P_0, Q_0 = Q_0, Sn = 2220, T1q0 = 1, T2d0 = 0.03, T2q0 = 0.07, Taa = 0.002, V_0 = V_0, V_b = V_b, Vn = 400, angle_0 = angle_0, ra = 0.003, x1d = 0.3, x1q = 0.65, x2d = 0.23, x2q = 0.25, xd = 1.81, xq = 1.76) annotation (
          Placement(visible = true, transformation(origin = {9, -5}, extent = {{-15, -15}, {15, 15}}, rotation = 0)));
        OpenIPSL.Electrical.Controls.PSAT.AVR.AVRtypeIII aVRtypeIII(K0 = 200, T1 = 1, T2 = 1, Te = 0.0001, Tr = 0.015, vfmax = 7, vfmin = -6.4) annotation (
          Placement(visible = true, transformation(origin = {-52, 6}, extent = {{-12, -12}, {12, 12}}, rotation = 0)));
        Modelica.Blocks.Sources.Constant pss_off(k = 0) annotation (
          Placement(visible = true, transformation(origin = {-88, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      equation
        connect(order6.pm0, order6.pm) annotation (
          Line(points = {{-4, -22}, {-4, -22}, {-4, -30}, {-18, -30}, {-18, -12}, {-10, -12}, {-10, -12}}, color = {0, 0, 127}));
        connect(order6.v, aVRtypeIII.v) annotation (
          Line(points = {{26, 0}, {38, 0}, {38, 26}, {-70, 26}, {-70, 12}, {-62, 12}, {-62, 12}}, color = {0, 0, 127}));
        connect(order6.vf0, aVRtypeIII.vf0) annotation (
          Line(points = {{-3, 12}, {-3, 24}, {-52, 24}, {-52, 18}}, color = {0, 0, 127}));
        connect(aVRtypeIII.vf, order6.vf) annotation (
          Line(points = {{-38, 6}, {-23, 6}, {-23, 3}, {-9, 3}}, color = {0, 0, 127}));
        connect(order6.p, pwPin) annotation (
          Line(points = {{24, -5}, {62, -5}, {62, 0}, {110, 0}}, color = {0, 0, 255}));
        connect(pss_off.y, aVRtypeIII.vs) annotation (
          Line(points = {{-76, 0}, {-64, 0}, {-64, 0}, {-62, 0}}, color = {0, 0, 127}));
      end Generator;
    end Generator;

    model Network
      Examples.Example_1.Generator.Generator G1(P_0 = 1997.999, Q_0 = 967.92, V_0 = 1, V_b = 400, angle_0 = 28.3385, displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {-88, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B1(displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {-60, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B2(displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {-20, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.Bus B3(displayPF = true) annotation (
        Placement(visible = true, transformation(origin = {68, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      inner OpenIPSL.Electrical.SystemBase SysData(S_b = 100, fn = 60) annotation (
        Placement(visible = true, transformation(origin = {-70, 85}, extent = {{-30, -15}, {30, 15}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PSAT.TwoWindingTransformer twoWindingTransformer(Sn = 2220, V_b = 400, Vn = 400, kT = 1, r = 0.0, x = 0.15) annotation (
        Placement(visible = true, transformation(origin = {-40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine1(B = 0.0, G = 0.0, R = 0.0, X = 0.5 * 100 / 2220) annotation (
        Placement(visible = true, transformation(origin = {26, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Branches.PwLine pwLine2(B = 0.0, G = 0.0, R = 0.0, X = 0.93 * 100 / 2220) annotation (
        Placement(visible = true, transformation(origin = {44, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Buses.InfiniteBus infiniteBus(P_0 = -1998, Q_0 = 87.066, V_0 = 0.90081, V_b = 400, angle_0 = 0.0) annotation (
        Placement(visible = true, transformation(origin = {90, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
      OpenIPSL.Electrical.Events.PwFault pwFault(R = 0.0, X = 0.01 * 100 / 2220, t1 = 0.5, t2 = 0.57) annotation (
        Placement(visible = true, transformation(origin = {2, -38}, extent = {{-6, -6}, {6, 6}}, rotation = 0)));
      OpenIPSL.Electrical.Events.Breaker breaker(
        enableTrigger=false,
        rc_enabled=false,
        t_o=0.57) annotation (
        Placement(visible = true, transformation(origin = {16, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(breaker.r, pwLine2.p) annotation (
        Line(points = {{26, -20}, {34, -20}, {34, -20}, {36, -20}}, color = {0, 0, 255}));
      connect(breaker.s, B2.p) annotation (
        Line(points = {{6, -20}, {-8, -20}, {-8, 0}, {-20, 0}, {-20, 0}}, color = {0, 0, 255}));
    connect(pwLine1.n, B3.p) annotation (
        Line(points = {{33, 20}, {60, 20}, {60, 0}, {68, 0}}, color = {0, 0, 255}));
    connect(pwLine1.p, B2.p) annotation (
        Line(points = {{15, 20}, {-8, 20}, {-8, 0}, {-20, 0}}, color = {0, 0, 255}));
    connect(pwLine2.n, B3.p) annotation (
        Line(points = {{51, -20}, {60, -20}, {60, 0}, {68, 0}}, color = {0, 0, 255}));
    connect(infiniteBus.p, B3.p) annotation (
        Line(points = {{80, 0}, {66, 0}}, color = {0, 0, 255}));
      connect(pwFault.p, B2.p) annotation (
        Line(points = {{-7, -38}, {-16, -38}, {-16, 0}, {-20, 0}}, color = {0, 0, 255}));
      connect(twoWindingTransformer.n, B2.p) annotation (
        Line(points = {{-28, 0}, {-20, 0}, {-20, 0}, {-20, 0}}, color = {0, 0, 255}));
      connect(twoWindingTransformer.p, B1.p) annotation (
        Line(points = {{-52, 0}, {-60, 0}, {-60, 0}, {-60, 0}}, color = {0, 0, 255}));
      connect(G1.pwPin, B1.p) annotation (
        Line(points = {{-76, 0}, {-62, 0}, {-62, 0}, {-60, 0}}, color = {0, 0, 255}));
    end Network;
  end Example_1Mod;
  annotation (
    uses(OpenIPSL(version = "1.5.0"), Modelica(version = "3.2.2")));
end Examples;
